#ifndef WALLPAPERINTERFACE_H
#define WALLPAPERINTERFACE_H

#include "../../universalinterface.h"
#include "workerobject.h"
#include <ukui-service-interface/serviceobject.h>
#include <QtDBus>

class WallpaperInterface : public UKUI::ServiceObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.ukui.ukcc.session.Wallpaper")
    Q_PROPERTY(QString wallpaperMode READ getWallpaperMode)
    Q_PROPERTY(QString displayType READ getDisplayType)
    Q_PROPERTY(QString wallpaper READ getWallpaper)
    Q_PROPERTY(QStringList previewWallpapers READ getPreviewWallpapers)
    Q_PROPERTY(QStringList sourceWallpapers READ getSourceWallpapers)

public:
    WallpaperInterface();
    ~WallpaperInterface();
    QString getWallpaperMode(); // 背景
    QString getDisplayType();  // 显示方式
    QString getWallpaper();
    QStringList getPreviewWallpapers();
    QStringList getSourceWallpapers();

public Q_SLOTS:
    void setDisplayType(QString type);
    void setWallpaper(QString mode, QString data);
    void resetDefault();

private:
    void changeGlobalTheme();

private:
    QStringList previewWallpaperList;
    QStringList sourceWallpaperList;
    QString mWallpaperMode;
    QString mDisplayType;
    QString mWallpaper;

Q_SIGNALS:
    void changed(QString key);
};

#endif // WALLPAPERINTERFACE_H
